/* ********************************************************************** */
/*                            UPDATE 1.3.03_002                           */
/* ---------------------------------------------------------------------- */

CREATE TABLE labo.certifier
(
id              SERIAL PRIMARY KEY,
label           VARCHAR DEFAULT '',
certificate     TEXT DEFAULT NULL,
last_modified	TIMESTAMP DEFAULT 'now'
);
ALTER TABLE labo.certifier ADD CONSTRAINT unique_label UNIQUE (label);


-- insert the labo Root CAs of Tudor and the Agence-eSanté
INSERT INTO labo.certifier
(label, certificate, last_modified)
VALUES
('chain', null, 'now'),
('labo.admin.healthnet.lu/home/ftp/labokeys/chainCA.crt', E'-----BEGIN CERTIFICATE-----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-----END CERTIFICATE-----
-----BEGIN CERTIFICATE-----
MIIFqDCCA5ACCQCrxQrHsnHVhTANBgkqhkiG9w0BAQUFADCBlTELMAkGA1UEBhMC
TFUxEzARBgNVBAgTCkx1eGVtYm91cmcxEzARBgNVBAcTCkx1eGVtYm91cmcxFjAU
BgNVBAoTDUFnZW5jZSBlU2FudGUxIDAeBgNVBAsTF0NlcnRpZmljYXRpb24gQXV0
aG9yaXR5MSIwIAYJKoZIhvcNAQkBFhNjYUBhZ2VuY2UtZXNhbnRlLmx1MB4XDTEz
MDEwNzA2MjgxMVoXDTIxMDEwNzA2MjgxMVowgZUxCzAJBgNVBAYTAkxVMRMwEQYD
VQQIEwpMdXhlbWJvdXJnMRMwEQYDVQQHEwpMdXhlbWJvdXJnMRYwFAYDVQQKEw1B
Z2VuY2UgZVNhbnRlMSAwHgYDVQQLExdDZXJ0aWZpY2F0aW9uIEF1dGhvcml0eTEi
MCAGCSqGSIb3DQEJARYTY2FAYWdlbmNlLWVzYW50ZS5sdTCCAiIwDQYJKoZIhvcN
AQEBBQADggIPADCCAgoCggIBAMfLT2D4sXjFsjZLUybRALzbSvd0Rz1Q7fHltQ5R
55bqmMWPQR5hvYuHjCUNuZ7+m/Fy7b/Z+lkkDRRdbMLtY7VvuACn7XSg0tjY4UWz
LhrurVL/U1WH76l9jzDAAtlIRxnJ+4Os5J++AOwWBA5Zx2BZg0nSBheuRTyJeHuX
QMU9yrKtBuiBN3wo9U+/nxQpUlk5J7/XydpXp8Z3+RgBuMykzJfTvJFxe6ORk/RQ
jYl6P6UUqARG31mbzapNNq7Tpr9Ecpx3lpSwIvxg0fte61LVFPlcJxidrcNBFRaj
w6xKZR0CRU7VeEiSswh/CXObIH8PEdoOIjw95tJXGiXp57ce9QP34nKn10mWJ0fr
uP6SlGLx89hxsoLnlYScNDIKQFLy6Q0t9PhxNA9Nod28zPu9aZXgey7My//ODh6h
6x5/XwQO1AhiRyJ7JRLzjSgRCLnjNhQsZhKiTv24shTsWZBpOcY789rqtONJWVV1
B9OTZTJ9FpzRHWlex+HwmM2Koy1bzpGBYsCKJmw9rG3hoj1gJzYgl42xdpMDXzjo
FddfqoKWvdRkKPFrHcUQI4nvYVbj/o7xWUAPcBX8/ePpymc0u/FJAsU2ELiy+U3+
s/SikqpkuiGcDvg+/6YGjVN8qeVTbdcgeohAuaOQ7/ZyE4sLfcmM/85p5F+760ak
QAhrAgMBAAEwDQYJKoZIhvcNAQEFBQADggIBAHJMt+CM/0g1oxNzzCouv9It4Rij
9fqmgDYIXAiSTY3CGkZ7EmJ/gDhxxgkVkd7atnau0XsRka/35QXJCSs7oTqK9WeK
v9NgHRkuwtoScolFdnxsCu0aY1aGSoBmxdIxqwESi5k1FDj/pf3H+gs5VSY0YeQQ
q2Fz8FDA/YCeX/wKTvHSmBFacM+ajPgC1HONpySHyUcg1RFyr0D/e+RXTOGCf986
MWmFF6BA8yRdAj0ELULqzzqKR2CJeu1nmlL9ScIRqK6WsovwbOCcjmjcPU+nu9eQ
AZiju0/w32ek/XNzUMfv+LQFxcY9IHxtm2M8f569HofvahlN3/leTq++qqscSgbu
wT8EMb/+SmidbrWWzpdDY8ZhsxnvcEgSjlcu7vr7MbyfI4wAOXFZULJB+rHYjW5/
7phXT0E6GBkh1nYU9soewbWmfn4P2WNdHCzLSRM6HqkdQjIxGEu72yy0or9A0i8N
cIXDoBQ1JSYy/L4W+V05BKqE3mLB1bmc9chrrlsZ/ggOdLJwg3KfMAE8MJmfDCEd
8Q02EQA1GyG+7fMUO2i1gouycjL5nSKYZMRthJej0nATRlCSAARLxF4DH2bXYT9d
w3o8HnvgxIiqhsas5U69AatYAFGHSbwnmKqgPhPk2vAl01Hem9y28vn7397HPm5n
5LCkgp+wnlBinE+F
-----END CERTIFICATE-----
-----BEGIN CERTIFICATE-----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-----END CERTIFICATE-----', '2013-05-08 10:53:00.000');


CREATE OR REPLACE FUNCTION labo.insert_delete_certifier_function ()
  RETURNS TRIGGER AS $$
BEGIN
  UPDATE labo.certifier
  SET certificate = NULL 
  WHERE label = 'chain';
  
  RETURN NEW;
END $$ LANGUAGE plpgsql;


CREATE OR REPLACE FUNCTION labo.update_certifier_function ()
  RETURNS TRIGGER AS $$
BEGIN
  IF NEW.label <> 'chain'
      AND not_equals(OLD.certificate, NEW.certificate)
  THEN
    UPDATE labo.certifier
    SET certificate = NULL 
    WHERE label = 'chain';

    UPDATE labo.certifier
    SET last_modified = 'now'::TIMESTAMP
    WHERE id = NEW.id;
  END IF;
  
  RETURN NEW;
END $$ LANGUAGE plpgsql;


DROP TRIGGER IF EXISTS update_chain_after_insert ON labo.certifier;
CREATE TRIGGER update_chain_after_insert
AFTER INSERT ON labo.certifier FOR EACH ROW
EXECUTE PROCEDURE labo.insert_delete_certifier_function();

DROP TRIGGER IF EXISTS update_chain_after_delete ON labo.certifier;
CREATE TRIGGER update_chain_after_delete
AFTER DELETE ON labo.certifier FOR EACH ROW
EXECUTE PROCEDURE labo.insert_delete_certifier_function();

DROP TRIGGER IF EXISTS update_chain_after_update ON labo.certifier;
CREATE TRIGGER update_chain_after_update
AFTER UPDATE ON labo.certifier FOR EACH ROW
EXECUTE PROCEDURE labo.update_certifier_function();



/**** UPDATE THE SCRIPTNAME BELOW TO THE FILENAME OF THIS FILE !!!!!!!! *****/
INSERT INTO "core"."info" (date,key,value) VALUES ('now','LAST_UPDATE' ,'db_update_1.3.03_002.sql');
